=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2014-09-13 14:29:31 +0000
+++ CMakeLists.txt	2014-11-25 00:55:20 +0000
@@ -25,7 +25,7 @@
 # Vala
 find_package (Vala REQUIRED)
 include (ValaVersion)
-ensure_vala_version ("0.22" MINIMUM)
+ensure_vala_version ("0.26" MINIMUM)
 include (ValaPrecompile)
 
 # Add 'make dist' command for creating release tarball
@@ -47,27 +47,28 @@
 
 find_package(Vala REQUIRED)
 include(ValaVersion)
-ensure_vala_version("0.18.0" MINIMUM)
+ensure_vala_version("0.26.0" MINIMUM)
 
 include(ValaPrecompile)
 vala_precompile(VALA_C
     src/Utils/Document.vala
-    src/Utils/Editor.vala
     src/Utils/FileChooser.vala
+    src/Utils/Stylesheet.vala
+    src/Utils/TextEditor.vala
     src/Utils/TextRange.vala
     src/Utils/ZeitgeistLogger.vala
     src/Widgets/ButtonGroup.vala
-    src/Widgets/EditorToolBar.vala
     src/Widgets/EditorView.vala
     src/Widgets/ImageToolBar.vala
     src/Widgets/TableChooser.vala
     src/Widgets/TableToolBar.vala
+    src/Widgets/TextToolBar.vala
     src/Widgets/TitleBar.vala
     src/Widgets/ToolBar.vala
     src/Widgets/WelcomeView.vala
     src/config.vala
+    src/MainWindow.vala
     src/Writer.vala
-    src/MainWindow.vala
 PACKAGES
     gtk+-3.0
     granite
@@ -86,4 +87,4 @@
 install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/writer.desktop DESTINATION share/applications)
 IF (EXISTS (${CMAKE_CURRENT_SOURCE_DIR}/data/writer.svg))
     install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/writer.svg DESTINATION share/icons/hicolor/48x48/apps)
-ENDIF ()
\ No newline at end of file
+ENDIF ()

=== modified file 'INSTALL'
--- INSTALL	2014-09-05 01:46:13 +0000
+++ INSTALL	2014-11-25 00:55:20 +0000
@@ -6,7 +6,7 @@
   If you don't have the source yet:
   bzr branch lp:writer
   cd writer
-  mkdir build; cd build
+  mkdir install; cd install
   cmake .. -DCMAKE_INSTALL_PREFIX=/usr
   make
   ./writer

=== added file 'Writer.avprj'
--- Writer.avprj	1970-01-01 00:00:00 +0000
+++ Writer.avprj	2014-11-25 00:55:20 +0000
@@ -0,0 +1,5 @@
+### AutoVala Project ###
+autovala_version: 13
+project_name: Writer
+*vala_version: 0.26
+

=== added file 'cmake/CMakeLists.txt'
--- cmake/CMakeLists.txt	1970-01-01 00:00:00 +0000
+++ cmake/CMakeLists.txt	2014-11-25 00:55:20 +0000
@@ -0,0 +1,17 @@
+### CMakeLists automatically created with AutoVala
+### Do not edit
+
+IF(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/)
+	install(DIRECTORY
+		${CMAKE_CURRENT_SOURCE_DIR}/
+	DESTINATION
+		share/autovala/cmake
+	)
+ELSE()
+	install(FILES
+		${CMAKE_CURRENT_SOURCE_DIR}/
+	DESTINATION
+		share/autovala/cmake
+	)
+ENDIF()
+

=== removed file 'cmake/FindGirCompiler.cmake'
--- cmake/FindGirCompiler.cmake	2014-09-05 01:46:13 +0000
+++ cmake/FindGirCompiler.cmake	1970-01-01 00:00:00 +0000
@@ -1,56 +0,0 @@
-##
-# Copyright 2009-2010 Jakob Westhoff. All rights reserved.
-# 
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions are met:
-# 
-#    1. Redistributions of source code must retain the above copyright notice,
-#       this list of conditions and the following disclaimer.
-# 
-#    2. Redistributions in binary form must reproduce the above copyright notice,
-#       this list of conditions and the following disclaimer in the documentation
-#       and/or other materials provided with the distribution.
-# 
-# THIS SOFTWARE IS PROVIDED BY JAKOB WESTHOFF ``AS IS'' AND ANY EXPRESS OR
-# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
-# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
-# EVENT SHALL JAKOB WESTHOFF OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
-# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
-# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
-# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
-# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
-# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-# 
-# The views and conclusions contained in the software and documentation are those
-# of the authors and should not be interpreted as representing official policies,
-# either expressed or implied, of Jakob Westhoff
-##
-
-##
-# Find module for the Gir compiler (g-ir-compiler)
-#
-# This module determines wheter a Gir compiler is installed on the current
-# system and where its executable is.
-#
-# Call the module using "find_package(GirCompiler) from within your CMakeLists.txt.
-#
-# The following variables will be set after an invocation:
-#
-#  G_IR_COMPILER_FOUND       Whether the g-ir-compiler compiler has been found or not
-#  G_IR_COMPILER_EXECUTABLE  Full path to the g-ir-compiler executable if it has been found
-##
-
-
-# Search for the g-ir-compiler executable in the usual system paths.
-find_program (G_IR_COMPILER_EXECUTABLE
-  NAMES g-ir-compiler)
-
-# Handle the QUIETLY and REQUIRED arguments, which may be given to the find call.
-# Furthermore set G_IR_COMPILER_FOUND to TRUE if the g-ir-compiler has been found (aka.
-# G_IR_COMPILER_EXECUTABLE is set)
-
-include (FindPackageHandleStandardArgs)
-find_package_handle_standard_args (GirCompiler DEFAULT_MSG G_IR_COMPILER_EXECUTABLE)
-
-mark_as_advanced (G_IR_COMPILER_EXECUTABLE)

=== modified file 'cmake/FindVala.cmake'
--- cmake/FindVala.cmake	2014-09-05 01:46:13 +0000
+++ cmake/FindVala.cmake	2014-11-25 00:55:20 +0000
@@ -1,5 +1,6 @@
 ##
-# Copyright 2009-2010 Jakob Westhoff. All rights reserved.
+# Copyright 2009-2010 Jakob Westhoff, 2014 Raster Software Vigo
+# All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -44,22 +45,36 @@
 
 
 # Search for the valac executable in the usual system paths.
-find_program(VALA_EXECUTABLE
-  NAMES valac)
+find_program(VALA_EXECUTABLE NAMES valac)
+
+if (VALA_EXECUTABLE STREQUAL "VALA_EXECUTABLE-NOTFOUND")
+
+# if valac executable is not found, it can be that valac is not installed, or
+# that the OS is source-based (like gentoo), and doesn't do a link from
+# valac-X.YY to valac. In that case, search for the specific valac binary after
+
+	if (NOT VALA_DEFERRING_COMPILER_SEARCH)
+		message (STATUS "VALAC not found. Deferring compiler search")
+	endif(NOT VALA_DEFERRING_COMPILER_SEARCH)
+	set(VALA_DEFERRING_COMPILER_SEARCH TRUE)
+	unset(VALA_EXECUTABLE)
+	unset(VALA_VERSION)
+
+else(VALA_EXECUTABLE STREQUAL "VALA_EXECUTABLE-NOTFOUND")
 
 # Handle the QUIETLY and REQUIRED arguments, which may be given to the find call.
 # Furthermore set VALA_FOUND to TRUE if Vala has been found (aka.
 # VALA_EXECUTABLE is set)
 
-include(FindPackageHandleStandardArgs)
-find_package_handle_standard_args(Vala DEFAULT_MSG VALA_EXECUTABLE)
+	include(FindPackageHandleStandardArgs)
+	find_package_handle_standard_args(Vala DEFAULT_MSG VALA_EXECUTABLE)
 
-mark_as_advanced(VALA_EXECUTABLE)
+	mark_as_advanced(VALA_EXECUTABLE)
 
 # Determine the valac version
-if(VALA_FOUND)
-    execute_process(COMMAND ${VALA_EXECUTABLE} "--version" 
-                    OUTPUT_VARIABLE "VALA_VERSION")
-    string(REPLACE "Vala" "" "VALA_VERSION" ${VALA_VERSION})
-    string(STRIP ${VALA_VERSION} "VALA_VERSION")
-endif(VALA_FOUND)
+	if(VALA_FOUND)
+	    execute_process(COMMAND ${VALA_EXECUTABLE} "--version" OUTPUT_VARIABLE "VALA_VERSION")
+	    string(REPLACE "Vala" "" "VALA_VERSION" ${VALA_VERSION})
+	    string(STRIP ${VALA_VERSION} "VALA_VERSION")
+	endif(VALA_FOUND)
+endif(VALA_EXECUTABLE STREQUAL "VALA_EXECUTABLE-NOTFOUND")

=== added file 'cmake/FindValadoc.cmake'
--- cmake/FindValadoc.cmake	1970-01-01 00:00:00 +0000
+++ cmake/FindValadoc.cmake	2014-11-25 00:55:20 +0000
@@ -0,0 +1,20 @@
+
+# Search for the valadocc executable in the usual system paths.
+find_program(VALADOC_EXECUTABLE NAMES valadoc)
+
+# Handle the QUIETLY and REQUIRED arguments, which may be given to the find call.
+# Furthermore set VALA_FOUND to TRUE if Vala has been found (aka.
+# VALA_EXECUTABLE is set)
+
+include(FindPackageHandleStandardArgs)
+find_package_handle_standard_args(Valadoc DEFAULT_MSG VALADOC_EXECUTABLE)
+
+mark_as_advanced(VALADOC_EXECUTABLE)
+
+# Determine the valac version
+if(VALA_FOUND)
+    execute_process(COMMAND ${VALA_EXECUTABLE} "--version" 
+                    OUTPUT_VARIABLE "VALA_VERSION")
+    string(REPLACE "Vala" "" "VALA_VERSION" ${VALA_VERSION})
+    string(STRIP ${VALA_VERSION} "VALA_VERSION")
+endif(VALA_FOUND)

=== added file 'cmake/Makefile'
--- cmake/Makefile	1970-01-01 00:00:00 +0000
+++ cmake/Makefile	2014-11-25 00:55:20 +0000
@@ -0,0 +1,286 @@
+# CMAKE generated file: DO NOT EDIT!
+# Generated by "Unix Makefiles" Generator, CMake Version 2.8
+
+# Default target executed when no arguments are given to make.
+default_target: all
+.PHONY : default_target
+
+#=============================================================================
+# Special targets provided by cmake.
+
+# Disable implicit rules so canoncical targets will work.
+.SUFFIXES:
+
+# Remove some rules from gmake that .SUFFIXES does not remove.
+SUFFIXES =
+
+.SUFFIXES: .hpux_make_needs_suffix_list
+
+# Suppress display of executed commands.
+$(VERBOSE).SILENT:
+
+# A target that is always out of date.
+cmake_force:
+.PHONY : cmake_force
+
+#=============================================================================
+# Set environment variables for the build.
+
+# The shell in which to execute make rules.
+SHELL = /bin/sh
+
+# The CMake executable.
+CMAKE_COMMAND = /usr/bin/cmake
+
+# The command to remove a file.
+RM = /usr/bin/cmake -E remove -f
+
+# The top-level source directory on which CMake was run.
+CMAKE_SOURCE_DIR = /home/mefrio/Scrivania/cmake
+
+# The top-level build directory on which CMake was run.
+CMAKE_BINARY_DIR = /home/mefrio/Scrivania/cmake/cmake
+
+#=============================================================================
+# Targets provided globally by CMake.
+
+# Special rule for the target edit_cache
+edit_cache:
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running interactive CMake command-line interface..."
+	/usr/bin/cmake -i .
+.PHONY : edit_cache
+
+# Special rule for the target edit_cache
+edit_cache/fast: edit_cache
+.PHONY : edit_cache/fast
+
+# Special rule for the target install
+install: preinstall
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
+	/usr/bin/cmake -P cmake_install.cmake
+.PHONY : install
+
+# Special rule for the target install
+install/fast: preinstall/fast
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
+	/usr/bin/cmake -P cmake_install.cmake
+.PHONY : install/fast
+
+# Special rule for the target install/local
+install/local: preinstall
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
+	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
+.PHONY : install/local
+
+# Special rule for the target install/local
+install/local/fast: install/local
+.PHONY : install/local/fast
+
+# Special rule for the target install/strip
+install/strip: preinstall
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
+	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
+.PHONY : install/strip
+
+# Special rule for the target install/strip
+install/strip/fast: install/strip
+.PHONY : install/strip/fast
+
+# Special rule for the target list_install_components
+list_install_components:
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
+.PHONY : list_install_components
+
+# Special rule for the target list_install_components
+list_install_components/fast: list_install_components
+.PHONY : list_install_components/fast
+
+# Special rule for the target rebuild_cache
+rebuild_cache:
+	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
+	/usr/bin/cmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
+.PHONY : rebuild_cache
+
+# Special rule for the target rebuild_cache
+rebuild_cache/fast: rebuild_cache
+.PHONY : rebuild_cache/fast
+
+# The main all target
+all: cmake_check_build_system
+	$(CMAKE_COMMAND) -E cmake_progress_start /home/mefrio/Scrivania/cmake/cmake/CMakeFiles /home/mefrio/Scrivania/cmake/cmake/CMakeFiles/progress.marks
+	$(MAKE) -f CMakeFiles/Makefile2 all
+	$(CMAKE_COMMAND) -E cmake_progress_start /home/mefrio/Scrivania/cmake/cmake/CMakeFiles 0
+.PHONY : all
+
+# The main clean target
+clean:
+	$(MAKE) -f CMakeFiles/Makefile2 clean
+.PHONY : clean
+
+# The main clean target
+clean/fast: clean
+.PHONY : clean/fast
+
+# Prepare targets for installation.
+preinstall: all
+	$(MAKE) -f CMakeFiles/Makefile2 preinstall
+.PHONY : preinstall
+
+# Prepare targets for installation.
+preinstall/fast:
+	$(MAKE) -f CMakeFiles/Makefile2 preinstall
+.PHONY : preinstall/fast
+
+# clear depends
+depend:
+	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
+.PHONY : depend
+
+#=============================================================================
+# Target rules for targets named scratch
+
+# Build rule for target.
+scratch: cmake_check_build_system
+	$(MAKE) -f CMakeFiles/Makefile2 scratch
+.PHONY : scratch
+
+# fast build rule for target.
+scratch/fast:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/build
+.PHONY : scratch/fast
+
+src/entry.o: src/entry.c.o
+.PHONY : src/entry.o
+
+# target to build an object file
+src/entry.c.o:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/entry.c.o
+.PHONY : src/entry.c.o
+
+src/entry.i: src/entry.c.i
+.PHONY : src/entry.i
+
+# target to preprocess a source file
+src/entry.c.i:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/entry.c.i
+.PHONY : src/entry.c.i
+
+src/entry.s: src/entry.c.s
+.PHONY : src/entry.s
+
+# target to generate assembly for a file
+src/entry.c.s:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/entry.c.s
+.PHONY : src/entry.c.s
+
+src/main_window.o: src/main_window.c.o
+.PHONY : src/main_window.o
+
+# target to build an object file
+src/main_window.c.o:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/main_window.c.o
+.PHONY : src/main_window.c.o
+
+src/main_window.i: src/main_window.c.i
+.PHONY : src/main_window.i
+
+# target to preprocess a source file
+src/main_window.c.i:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/main_window.c.i
+.PHONY : src/main_window.c.i
+
+src/main_window.s: src/main_window.c.s
+.PHONY : src/main_window.s
+
+# target to generate assembly for a file
+src/main_window.c.s:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/main_window.c.s
+.PHONY : src/main_window.c.s
+
+src/menu.o: src/menu.c.o
+.PHONY : src/menu.o
+
+# target to build an object file
+src/menu.c.o:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/menu.c.o
+.PHONY : src/menu.c.o
+
+src/menu.i: src/menu.c.i
+.PHONY : src/menu.i
+
+# target to preprocess a source file
+src/menu.c.i:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/menu.c.i
+.PHONY : src/menu.c.i
+
+src/menu.s: src/menu.c.s
+.PHONY : src/menu.s
+
+# target to generate assembly for a file
+src/menu.c.s:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/menu.c.s
+.PHONY : src/menu.c.s
+
+src/notebook.o: src/notebook.c.o
+.PHONY : src/notebook.o
+
+# target to build an object file
+src/notebook.c.o:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/notebook.c.o
+.PHONY : src/notebook.c.o
+
+src/notebook.i: src/notebook.c.i
+.PHONY : src/notebook.i
+
+# target to preprocess a source file
+src/notebook.c.i:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/notebook.c.i
+.PHONY : src/notebook.c.i
+
+src/notebook.s: src/notebook.c.s
+.PHONY : src/notebook.s
+
+# target to generate assembly for a file
+src/notebook.c.s:
+	$(MAKE) -f CMakeFiles/scratch.dir/build.make CMakeFiles/scratch.dir/src/notebook.c.s
+.PHONY : src/notebook.c.s
+
+# Help Target
+help:
+	@echo "The following are some of the valid targets for this Makefile:"
+	@echo "... all (the default if no target is provided)"
+	@echo "... clean"
+	@echo "... depend"
+	@echo "... edit_cache"
+	@echo "... install"
+	@echo "... install/local"
+	@echo "... install/strip"
+	@echo "... list_install_components"
+	@echo "... rebuild_cache"
+	@echo "... scratch"
+	@echo "... src/entry.o"
+	@echo "... src/entry.i"
+	@echo "... src/entry.s"
+	@echo "... src/main_window.o"
+	@echo "... src/main_window.i"
+	@echo "... src/main_window.s"
+	@echo "... src/menu.o"
+	@echo "... src/menu.i"
+	@echo "... src/menu.s"
+	@echo "... src/notebook.o"
+	@echo "... src/notebook.i"
+	@echo "... src/notebook.s"
+.PHONY : help
+
+
+
+#=============================================================================
+# Special targets to cleanup operation of make.
+
+# Special rule to run CMake to check the build system integrity.
+# No rule that depends on this can have commands that come from listfiles
+# because they might be regenerated.
+cmake_check_build_system:
+	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 0
+.PHONY : cmake_check_build_system
+

=== modified file 'cmake/Translations.cmake'
--- cmake/Translations.cmake	2014-09-05 01:46:13 +0000
+++ cmake/Translations.cmake	2014-11-25 00:55:20 +0000
@@ -3,17 +3,6 @@
 macro(add_translations_directory NLS_PACKAGE)
     add_custom_target (i18n ALL COMMENT “Building i18n messages.”)
     find_program (MSGFMT_EXECUTABLE msgfmt)
-    # be sure that all languages are present
-    set (LANGUAGES_NEEDED af am ar ast az be bg bn bs ca ckb cs da de el en_AU en_CA en_GB eo es et eu fa fi fr fr_CA gl he hi hr hu hy id it ja ka ko ky lb lo lt lv ml mr ms nb nl nn pl pt pt_BR ro ru rue si sk sl sma sq sr sv sw ta te th tr uk vi zh_CN zh_HK zh_TW)
-    foreach (LANGUAGE_NEEDED ${LANGUAGES_NEEDED})
-        if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${LANGUAGE_NEEDED}.po)
-            file (APPEND ${CMAKE_CURRENT_SOURCE_DIR}/${LANGUAGE_NEEDED}.po "msgid \"\"\n")
-            file (APPEND ${CMAKE_CURRENT_SOURCE_DIR}/${LANGUAGE_NEEDED}.po "msgstr \"\"\n")
-            file (APPEND ${CMAKE_CURRENT_SOURCE_DIR}/${LANGUAGE_NEEDED}.po "\"MIME-Version: 1.0\\n\"\n")
-            file (APPEND ${CMAKE_CURRENT_SOURCE_DIR}/${LANGUAGE_NEEDED}.po "\"Content-Type: text/plain; charset=UTF-8\\n\"\n")
-        endif ()
-    endforeach (LANGUAGE_NEEDED ${LANGUAGES_NEEDED})
-    # generate .mo from .po
     file (GLOB PO_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
     foreach (PO_INPUT ${PO_FILES})
         get_filename_component (PO_INPUT_BASE ${PO_INPUT} NAME_WE)
@@ -26,6 +15,7 @@
     endforeach (PO_INPUT ${PO_FILES})
 endmacro(add_translations_directory)
 
+
 macro(add_translations_catalog NLS_PACKAGE)
     add_custom_target (pot COMMENT “Building translation catalog.”)
     find_program (XGETTEXT_EXECUTABLE xgettext)
@@ -37,17 +27,17 @@
     foreach(FILES_INPUT ${ARGN})
         set(BASE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${FILES_INPUT})
 
-        file (GLOB_RECURSE SOURCE_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/ ${BASE_DIRECTORY}/*.c)
+        file (GLOB_RECURSE SOURCE_FILES ${BASE_DIRECTORY}/*.c)
         foreach(C_FILE ${SOURCE_FILES})
             set(C_SOURCE ${C_SOURCE} ${C_FILE})
         endforeach()
 
-        file (GLOB_RECURSE SOURCE_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/ ${BASE_DIRECTORY}/*.vala)
+        file (GLOB_RECURSE SOURCE_FILES ${BASE_DIRECTORY}/*.vala)
         foreach(VALA_C_FILE ${SOURCE_FILES})
             set(VALA_SOURCE ${VALA_SOURCE} ${VALA_C_FILE})
         endforeach()
 
-        file (GLOB_RECURSE SOURCE_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/ ${BASE_DIRECTORY}/*.ui)
+        file (GLOB_RECURSE SOURCE_FILES ${BASE_DIRECTORY}/*.ui)
         foreach(GLADE_C_FILE ${SOURCE_FILES})
             set(GLADE_SOURCE ${GLADE_SOURCE} ${GLADE_C_FILE})
         endforeach()
@@ -56,21 +46,21 @@
     set(BASE_XGETTEXT_COMMAND
         ${XGETTEXT_EXECUTABLE} -d ${NLS_PACKAGE}
         -o ${CMAKE_CURRENT_SOURCE_DIR}/${NLS_PACKAGE}.pot
-        --add-comments="/" --keyword="_" --keyword="N_" --keyword="C_:1c,2" --keyword="NC_:1c,2" --keyword="ngettext:1,2" --keyword="Q_:1g" --from-code=UTF-8)
+        --keyword="_" --keyword="N_" --from-code=UTF-8)
 
    set(CONTINUE_FLAG "")
 
     IF(NOT "${C_SOURCE}" STREQUAL "")
-        add_custom_command(TARGET pot WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} COMMAND ${BASE_XGETTEXT_COMMAND} ${C_SOURCE})
+        add_custom_command(TARGET pot COMMAND ${BASE_XGETTEXT_COMMAND} ${C_SOURCE})
         set(CONTINUE_FLAG "-j")
     ENDIF()
 
     IF(NOT "${VALA_SOURCE}" STREQUAL "")
-        add_custom_command(TARGET pot WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} COMMAND ${BASE_XGETTEXT_COMMAND} ${CONTINUE_FLAG} -LC\# ${VALA_SOURCE})
+        add_custom_command(TARGET pot COMMAND ${BASE_XGETTEXT_COMMAND} ${CONTINUE_FLAG} -LC\# ${VALA_SOURCE})
         set(CONTINUE_FLAG "-j")
     ENDIF()
 
     IF(NOT "${GLADE_SOURCE}" STREQUAL "")
-        add_custom_command (TARGET pot WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} COMMAND ${BASE_XGETTEXT_COMMAND} ${CONTINUE_FLAG} -LGlade ${GLADE_SOURCE})
+        add_custom_command (TARGET pot COMMAND ${BASE_XGETTEXT_COMMAND} ${CONTINUE_FLAG} -LGlade ${GLADE_SOURCE})
     ENDIF()  
-endmacro()
\ No newline at end of file
+endmacro()

=== modified file 'cmake/ValaPrecompile.cmake'
--- cmake/ValaPrecompile.cmake	2014-09-05 01:46:13 +0000
+++ cmake/ValaPrecompile.cmake	2014-11-25 00:55:20 +0000
@@ -118,7 +118,7 @@
     parse_arguments(ARGS "TARGET;PACKAGES;OPTIONS;DIRECTORY;GENERATE_GIR;GENERATE_SYMBOLS;GENERATE_HEADER;GENERATE_VAPI;CUSTOM_VAPIS" "" ${ARGN})
 
     if(ARGS_DIRECTORY)
-        set(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${ARGS_DIRECTORY})
+        set(DIRECTORY ${ARGS_DIRECTORY})
     else(ARGS_DIRECTORY)
         set(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
     endif(ARGS_DIRECTORY)
@@ -144,8 +144,8 @@
         string(REPLACE ".gs" ".c" src ${src})
         if(${IS_MATCHED} MATCHES "/")
             get_filename_component(VALA_FILE_NAME ${src} NAME)
-            set(out_file "${CMAKE_CURRENT_BINARY_DIR}/${VALA_FILE_NAME}")
-            list(APPEND out_files "${CMAKE_CURRENT_BINARY_DIR}/${VALA_FILE_NAME}")
+            set(out_file "${DIRECTORY}/${VALA_FILE_NAME}")
+            list(APPEND out_files "${DIRECTORY}/${VALA_FILE_NAME}")
         else()
             set(out_file "${DIRECTORY}/${src}")
             list(APPEND out_files "${DIRECTORY}/${src}")
@@ -185,21 +185,10 @@
     endif(ARGS_GENERATE_HEADER)
 
     set(gir_arguments "")
-    set(gircomp_command "")
     if(ARGS_GENERATE_GIR)
         list(APPEND out_files "${DIRECTORY}/${ARGS_GENERATE_GIR}.gir")
         list(APPEND out_files_display "${ARGS_GENERATE_GIR}.gir")
         set(gir_arguments "--gir=${ARGS_GENERATE_GIR}.gir")
-
-        include (FindGirCompiler)
-        find_package(GirCompiler REQUIRED)
-        
-        set(gircomp_command 
-            COMMAND 
-                ${G_IR_COMPILER_EXECUTABLE}
-            ARGS 
-                "${DIRECTORY}/${ARGS_GENERATE_GIR}.gir"
-                -o "${DIRECTORY}/${ARGS_GENERATE_GIR}.typelib")
     endif(ARGS_GENERATE_GIR)
 
     set(symbols_arguments "")
@@ -211,7 +200,8 @@
 
     # Workaround for a bug that would make valac run twice. This file is written
     # after the vala compiler generates C source code.
-    set(OUTPUT_STAMP ${CMAKE_CURRENT_BINARY_DIR}/${target_name}_valac.stamp)
+    set (extra_name ${extra_name}_ )
+    set(OUTPUT_STAMP ${CMAKE_CURRENT_BINARY_DIR}/${target_name}${extra_name}valac.stamp)
 
     add_custom_command(
     OUTPUT
@@ -228,8 +218,6 @@
         "-d" ${DIRECTORY} 
         ${vala_pkg_opts} 
         ${ARGS_OPTIONS} 
-        "-g"
-        "--save-temps"
         ${in_files} 
         ${custom_vapi_arguments}
     COMMAND
@@ -241,7 +229,6 @@
         ${ARGS_CUSTOM_VAPIS}
     COMMENT
         "Generating ${out_files_display}"
-    ${gircomp_command}
     )
 
     # This command will be run twice for some reason (pass a non-empty string to COMMENT

=== modified file 'cmake/ValaVersion.cmake'
--- cmake/ValaVersion.cmake	2014-09-05 01:46:13 +0000
+++ cmake/ValaVersion.cmake	2014-11-25 00:55:20 +0000
@@ -1,15 +1,31 @@
 ##
-# Copyright 2009-2010 Jakob Westhoff. All rights reserved.
+# Copyright (C) 2014 Raster Software Vigo
+# Autovala is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# Autovala is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Copyright (C) 2013, Valama development team
+#
+# Copyright 2009-2010 Jakob Westhoff All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
 # 
-#    1. Redistributions of source code must retain the above copyright notice,
-#       this list of conditions and the following disclaimer.
+#	1. Redistributions of source code must retain the above copyright notice,
+#	   this list of conditions and the following disclaimer.
 # 
-#    2. Redistributions in binary form must reproduce the above copyright notice,
-#       this list of conditions and the following disclaimer in the documentation
-#       and/or other materials provided with the distribution.
+#	2. Redistributions in binary form must reproduce the above copyright notice,
+#	   this list of conditions and the following disclaimer in the documentation
+#	   and/or other materials provided with the distribution.
 # 
 # THIS SOFTWARE IS PROVIDED BY JAKOB WESTHOFF ``AS IS'' AND ANY EXPRESS OR
 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
@@ -51,46 +67,86 @@
 #
 # If no option is specified the version will be treated as a minimal version.
 ##
-macro(ensure_vala_version version)
-    parse_arguments(ARGS "" "MINIMUM;MAXIMUM;EXACT" ${ARGN})
-	set(compare_message "")
-	set(error_message "")
-	if(ARGS_MINIMUM)
-		set(compare_message "a minimum ")
-		set(error_message "or greater ")
-	elseif(ARGS_MAXIMUM)
-		set(compare_message "a maximum ")
-		set(error_message "or less ")
-	endif(ARGS_MINIMUM)
-	
-	message(STATUS 
-		"checking for ${compare_message}Vala version of ${version}"
-	)
-
-	unset(version_accepted)
-	
-	# MINIMUM is the default if no option is specified
-	if(ARGS_EXACT)
-		if(${VALA_VERSION} VERSION_EQUAL ${version} )
-			set(version_accepted TRUE)	
-		endif(${VALA_VERSION} VERSION_EQUAL ${version})
-	elseif(ARGS_MAXIMUM)
-		if(${VALA_VERSION} VERSION_LESS ${version} OR ${VALA_VERSION} VERSION_EQUAL ${version})
-			set(version_accepted TRUE)	
-		endif(${VALA_VERSION} VERSION_LESS ${version} OR ${VALA_VERSION} VERSION_EQUAL ${version})
-	else(ARGS_MAXIMUM)
-		if(${VALA_VERSION} VERSION_GREATER ${version} OR ${VALA_VERSION} VERSION_EQUAL ${version})
-			set(version_accepted TRUE)	
-		endif(${VALA_VERSION} VERSION_GREATER ${version} OR ${VALA_VERSION} VERSION_EQUAL ${version})
-	endif(ARGS_EXACT)
-
-	if (NOT version_accepted)
-		message(FATAL_ERROR 
-			"Vala version ${version} ${error_message}is required."
+macro(ensure_vala_version ensure_version)
+
+	if (USE_VALA_BINARY)
+		message(STATUS "Forced use of vala binary ${USE_VALA_BINARY}")
+		set(VALA_EXECUTABLE ${USE_VALA_BINARY})
+	else (USE_VALA_BINARY)
+
+		message(STATUS "checking for Vala version of valac-${ensure_version}")
+	
+		unset(version_accepted)
+		execute_process(COMMAND "valac-${ensure_version}" "--version"
+			OUTPUT_VARIABLE "VALA_VERSION" OUTPUT_STRIP_TRAILING_WHITESPACE)
+		if (NOT VALA_VERSION)
+	
+			find_program(VALA_EXECUTABLE "valac")
+	
+			# If the specific version asked for this project is not found,
+			# try to use the one pointed by the valac link
+	
+			parse_arguments(ARGS "" "MINIMUM;MAXIMUM;EXACT" ${ARGN})
+			set(compare_message "")
+			set(error_message "")
+			if(ARGS_MINIMUM)
+				set(compare_message "a minimum ")
+				set(error_message "or greater ")
+			elseif(ARGS_MAXIMUM)
+				set(compare_message "a maximum ")
+				set(error_message "or less ")
+			endif(ARGS_MINIMUM)
+	
+			message(STATUS "checking for ${compare_message}Vala version of ${ensure_version}" )
+	
+			execute_process(COMMAND ${VALA_EXECUTABLE} "--version"
+				OUTPUT_VARIABLE "VALA_VERSION" OUTPUT_STRIP_TRAILING_WHITESPACE)
+		else(NOT VALA_VERSION)
+			set(VALA_EXECUTABLE "valac-${ensure_version}")
+		endif(NOT VALA_VERSION)
+
+		# this code allows to identify development versions as the right version
+		# e.g. 0.19.1 -> 0.20 ; 0.20.1 -> 0.20 ; 0.24.0.2-2235 -> 0.26
+		# Thanks to Yannick Inizan
+		string(REPLACE "Vala" "" "VALA_VERSION" ${VALA_VERSION})
+		string(STRIP ${VALA_VERSION} "VALA_VERSION")
+		string(REPLACE "." ";" VALA_LIST "${VALA_VERSION}")
+		list(GET VALA_LIST 0 maj_ver)
+		list(GET VALA_LIST 1 min_ver)
+		list(GET VALA_LIST 2 rev_ver)
+		math(EXPR is_odd "${min_ver} % 2")
+		list(LENGTH VALA_LIST len)
+		if((${is_odd} EQUAL 1))
+			math(EXPR min_ver "${min_ver} + 1")
+		elseif(len GREATER 3)
+			math(EXPR min_ver "${min_ver} + 2")
+		endif()
+
+		set(VALA_SVERSION "${maj_ver}.${min_ver}" CACHE INTERNAL "")
+
+		# MINIMUM is the default if no option is specified
+		if(ARGS_EXACT)
+			if(${VALA_SVERSION} VERSION_EQUAL ${ensure_version} )
+				set(version_accepted TRUE)
+			endif(${VALA_SVERSION} VERSION_EQUAL ${ensure_version})
+		elseif(ARGS_MAXIMUM)
+			if(${VALA_SVERSION} VERSION_LESS ${ensure_version} OR ${VALA_SVERSION} VERSION_EQUAL ${ensure_version})
+				set(version_accepted TRUE)
+			endif(${VALA_SVERSION} VERSION_LESS ${ensure_version} OR ${VALA_SVERSION} VERSION_EQUAL ${ensure_version})
+		else(ARGS_MAXIMUM)
+			if(${VALA_SVERSION} VERSION_GREATER ${ensure_version} OR ${VALA_SVERSION} VERSION_EQUAL ${ensure_version})
+				set(version_accepted TRUE)
+			endif(${VALA_SVERSION} VERSION_GREATER ${ensure_version} OR ${VALA_SVERSION} VERSION_EQUAL ${ensure_version})
+		endif(ARGS_EXACT)
+	
+		if (NOT version_accepted)
+			message(FATAL_ERROR 
+				"Vala version ${ensure_version} ${error_message}is required."
+			)
+		endif(NOT version_accepted)
+	
+		message(STATUS
+			"  found Vala, version ${VALA_SVERSION}"
 		)
-	endif(NOT version_accepted)
-
-	message(STATUS
-		"  found Vala, version ${VALA_VERSION}"
-	)
+	endif(USE_VALA_BINARY)
 endmacro(ensure_vala_version)

=== added file 'cmake/Valadoc.cmake'
--- cmake/Valadoc.cmake	1970-01-01 00:00:00 +0000
+++ cmake/Valadoc.cmake	2014-11-25 00:55:20 +0000
@@ -0,0 +1,38 @@
+include(ParseArguments)
+find_package(Valadoc REQUIRED)
+
+macro(valadoc target outdir)
+	parse_arguments(ARGS "PACKAGES;OPTIONS;CUSTOM_VAPIS" "" ${ARGN})
+	set(vala_pkg_opts "")
+	foreach(pkg ${ARGS_PACKAGES})
+		list(APPEND vala_pkg_opts "--pkg=${pkg}")
+	endforeach(pkg ${ARGS_PACKAGES})
+
+	set(vapi_dir_opts "")
+	foreach(src ${ARGS_CUSTOM_VAPIS})
+		get_filename_component(pkg ${src} NAME_WE)
+		list(APPEND vala_pkg_opts "--pkg=${pkg}")
+		
+		get_filename_component(path ${src} PATH)
+		list(APPEND vapi_dir_opts "--vapidir=${path}")
+	endforeach(src ${ARGS_DEFAULT_ARGS})
+	list(REMOVE_DUPLICATES vapi_dir_opts)
+
+	add_custom_command(TARGET ${target}
+	COMMAND
+		${VALADOC_EXECUTABLE}
+	ARGS
+		"--force"
+		"-b" ${CMAKE_CURRENT_SOURCE_DIR}
+		"-o" ${outdir}
+		"--package-name=${CMAKE_PROJECT_NAME}"
+		"--package-version=${PROJECT_VERSION}"
+		${vala_pkg_opts}
+		${vapi_dir_opts}
+		${ARGS_OPTIONS}
+		${in_files} 
+	DEPENDS
+		${in_files}
+		${ARGS_CUSTOM_VAPIS}
+	)
+endmacro(valadoc)

=== added directory 'data/bash_completion'
=== added directory 'data/interface'
=== added directory 'data/local'
=== added directory 'data/pixmaps'
=== added directory 'doc'
=== modified file 'src/MainWindow.vala'
--- src/MainWindow.vala	2014-10-26 10:41:33 +0000
+++ src/MainWindow.vala	2014-11-25 00:55:20 +0000
@@ -131,4 +131,4 @@
             title_bar.title = doc.file.get_basename () + " (%s)".printf(path);
         }
     }
-}
\ No newline at end of file
+}

=== modified file 'src/Writer.vala'
--- src/Writer.vala	2014-10-26 10:41:33 +0000
+++ src/Writer.vala	2014-11-25 00:55:20 +0000
@@ -157,4 +157,4 @@
             app.run (args);
         }
     }
-}
\ No newline at end of file
+}

=== added directory 'src/vapis'
